; Assisted Bed Levelling
; for hotbeds with about 220 by 220 mm size
; and 12864 display with rotational encoder
; (c) 2018-2022 by alfrank@drucktipps3d.de

; performs 5 cycles of 
; going to each corner and the center of the bed
; waiting at each point for a click on the controller wheel
; to allow manual bed height adjustments
; by using the four thumbscrews under the bed

; CAUTION - BED & NOZZLE ARE HOT !!!

G21 ; set units to millimeters
G90 ; absolute positioning
M107 ; turn all fans off
M140 S50 ; set bed temperature
M104 S190 ; set hotend temperature
G28 X Y ; home X and Y axis
G28 Z ; home Z axis
M190 S50 ; wait for bed temperature
M109 S190 ; wait for hotend temperature


; Cycle 1 of 5

;Go to Position 1 - Front Left Corner
G1 Z10 F500
G1 X30 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 2 - Front Right Corner
G1 Z10 F500
G1 X190 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 3 - Rear Right Corner
G1 Z10 F500
G1 X190 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 4 - Rear Left Corner
G1 Z10 F500
G1 X30 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 5 - Center
G1 Z10 F500
G1 X110 Y110 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue


; Cycle 2 of 5

;Go to Position 1 - Front Left Corner
G1 Z10 F500
G1 X30 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 2 - Front Right Corner
G1 Z10 F500
G1 X190 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 3 - Rear Right Corner
G1 Z10 F500
G1 X190 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 4 - Rear Left Corner
G1 Z10 F500
G1 X30 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 5 - Center
G1 Z10 F500
G1 X110 Y110 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue


; Cycle 3 of 5

;Go to Position 1 - Front Left Corner
G1 Z10 F500
G1 X30 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 2 - Front Right Corner
G1 Z10 F500
G1 X190 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 3 - Rear Right Corner
G1 Z10 F500
G1 X190 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 4 - Rear Left Corner
G1 Z10 F500
G1 X30 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 5 - Center
G1 Z10 F500
G1 X110 Y110 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue


; Cycle 4 of 5

;Go to Position 1 - Front Left Corner
G1 Z10 F500
G1 X30 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 2 - Front Right Corner
G1 Z10 F500
G1 X190 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 3 - Rear Right Corner
G1 Z10 F500
G1 X190 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 4 - Rear Left Corner
G1 Z10 F500
G1 X30 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 5 - Center
G1 Z10 F500
G1 X110 Y110 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue


; Cycle 5 of 5

;Go to Position 1 - Front Left Corner
G1 Z10 F500
G1 X30 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 2 - Front Right Corner
G1 Z10 F500
G1 X190 Y30 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 3 - Rear Right Corner
G1 Z10 F500
G1 X190 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 4 - Rear Left Corner
G1 Z10 F500
G1 X30 Y190 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

;Go to Position 5 - Center
G1 Z10 F500
G1 X110 Y110 F3600
G1 Z0 F500
M400 ; wait for move to finish
M300 S880 P750 ;  beep at 880 Hz (A5) for 0.75 seconds
M0 Click to continue ; pause and display text
M108 ; wait for click and continue

G28 ; home all axis
M104 S0 ; turn off nozzle heating
M140 S0 ; turn off bed heating
M18 ; disable stepper motors
